package com.soundapp.alisajung.ambientsounds;

import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.Context;
import android.database.Cursor;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.net.Uri;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;

import java.io.IOException;
import java.util.ArrayList;

/**
 * Created by die_hexe on 27.05.2016.
 */
public class MediaImporter implements View.OnClickListener, AdapterView.OnItemClickListener {

    private ContentResolver contentResolver;
    private static String LOGTAG = "Media Importer";
    private ListView mediaListView;
    private Context context;
    private ArrayList arrayListTitles;
    private ArrayList<Long> arrayListIds;
    private ArrayAdapter arrayAdapater;

    public MediaImporter(ContentResolver contentResolver, ListView mediaListView, Context context){
        this.contentResolver = contentResolver;
        this.mediaListView = mediaListView;
        this.context = context;


        arrayListIds = new ArrayList<Long>();

        mediaListView.setOnItemClickListener(this);
    }

    @Override
    public void onClick(View v) {
        Uri uri = android.provider.MediaStore.Audio.Media.EXTERNAL_CONTENT_URI;
        Cursor cursor = contentResolver.query(uri, null, null, null, null);
        long lastid = 0;



        if (cursor == null) {
            Log.d(LOGTAG,"Cursor fail");
            // query failed, handle error.
        } else if (!cursor.moveToFirst()) {
            Log.d(LOGTAG, "Curser move fist fail");
            // no media on the device
        } else {
            Log.d(LOGTAG, "Stuff.");

            arrayListTitles = new ArrayList();
            arrayAdapater = new ArrayAdapter(context,android.R.layout.simple_list_item_1,arrayListTitles);
            mediaListView.setAdapter(arrayAdapater);
            int titleColumn = cursor.getColumnIndex(android.provider.MediaStore.Audio.Media.TITLE);
            int idColumn = cursor.getColumnIndex(android.provider.MediaStore.Audio.Media._ID);
            arrayListIds.clear();
            arrayListTitles.clear();
            do {
                long thisId = cursor.getLong(idColumn);
                String thisTitle = cursor.getString(titleColumn);

                Log.d(LOGTAG, "Logging!"+thisTitle);
                // ...process entry...
                lastid = thisId;
                arrayListTitles.add(thisTitle);
                arrayListIds.add(thisId);
            } while (cursor.moveToNext());

//            playSongWithID(lastid);
        }
    }

    public void playSongWithID(long id){
        Log.d(LOGTAG, "Try playing ");
        Uri contentUri = ContentUris.withAppendedId(
                android.provider.MediaStore.Audio.Media.EXTERNAL_CONTENT_URI, id);

        MediaPlayer mMediaPlayer = new MediaPlayer();
        mMediaPlayer.setAudioStreamType(AudioManager.STREAM_MUSIC);
        try {
            mMediaPlayer.setDataSource(context, contentUri);
        } catch (IOException e) {
            Log.d(LOGTAG, "Fail. mist.");
            e.printStackTrace();
        }
        try {
            mMediaPlayer.prepare();
        } catch (IOException e) {
            e.printStackTrace();
        }
        mMediaPlayer.start();
    }

    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        playSongWithID(arrayListIds.get(position));
    }
}
